( Webserver Demo CGI functions )
\ This demo requires: 
\   I2C, S-3590a, W5100, net-console, 
\   webserver, and tools are loaded.

\ List specified block contents
: WEX-LIST S" page=" web-valnum IF
    D>S DUP 0 blk-count WITHIN IF
      0 rsp-text
      LIST
    ELSE
      rsp-fail
      ." Page index must be a number from 0 to " blk-count 1- . CR
    THEN
  ELSE
    rsp-fail
    ." Page index is not a number " CR
  THEN ;

\ Display contents of a range of memory
: WEX-DUMP
  S" adr=" web-valnum IF
    D>S
    S" bytes=" web-valnum IF
      0 rsp-text
      D>S DUMP
    ELSE
      DROP
      rsp-fail
      ." Invalid byte count " CR
    THEN
  ELSE
    rsp-fail
    ." Invalid address " CR
  THEN ;

\ Display forth words, requires Tools.forth
: WEX-WORDS
  S" doit=" web-valstr IF
    DROP S" SEE" S= 0= IF
      S" word=" web-valstr IF
        ( we have a word to SEE, is the word valid )
        2DUP PAD >COUNTED
        PAD FIND IF
          DROP
          ( c-adrWord uLenWord )
          S" SEE " PAD >COUNTED
          ( copy word name string to buffer )
          ( c-adrWord uLenWord )
          PAD COUNT + SWAP DUP >R
          ( c-adrWord c-adrP uLenWord ) ( R: uLenWord )
          CMOVE
          ( update total string size )
          PAD C@ R> + PAD C!
          ( indicate a text responce )
          0 rsp-text 
          ( execute SEE command )
          PAD COUNT EVALUATE
        ELSE
          DROP
          2DROP
          rsp-fail
          ." Specified word not found!  " CR
        THEN
      ELSE
        rsp-fail
        ." No word specified!  " CR
      THEN
    ELSE
      0 rsp-text 
      S" Executing WORDS" com-debug
      WORDS
      S" WORDS DONE" com-debug
    THEN
  ELSE
    0 rsp-text 
    WORDS
  THEN ;

: send-html ( uBytes uFirstBlk -- )
  OVER rsp-html
  nc-flush
  ( uBytes uBlk )
  BEGIN
    OVER
  WHILE
    ( uBytes uBlk )
    OVER DUP 1024 > IF 
      DROP 1024 
    THEN
    ( uBytes uBlk uBytesToSend )
    OVER
    ( uBytes uBlk uBytesToSend uBlk )
    BLOCK SWAP
    ( uBytes uBlk c-adrBlk uBytesToSend )
    DUP >R
    ( uBytes uBlk c-adrBlk uBytesToSend ) ( R: uBytesToSend )
    nc_socket ROT ROT
    ( uBytes uBlk uSocket c-adrBlk uBytesToSend ) ( R: uBytesToSend )
    tcp-write DROP
    ( uBytes uBlk ) ( R: uBytesToSend )
    1+ SWAP R> - SWAP
    ( uBytes' uBlk' )
  REPEAT
  2DROP ;  

\ Load HTML post test page
: WEX-demo
  #1227 #34 send-html ;

